/* eslint-disable */
window.KGCallBackList = {};

window.KGJSBridge = {
    call:call,
    util:util,
};

String.prototype.hashCode = function() {
    var hash = 0;
    if (this.length == 0) return hash;
    for (var index = 0; index < this.length; index++) {
        var charactor = this.charCodeAt(index);
        hash = ((hash << 5) - hash) + charactor;
        hash = hash & hash;
    }
    return hash;
};

window.Callback = function(identifier, resultStatus, resultData) {

    callBackDict = window.KGCallBackList[identifier];

    if (callBackDict) {

        isFinished = true;
        if (resultStatus == "success") {
            callBackDict.success(resultData);
        }
        if (resultStatus == "fail") {
            callBackDict.fail(resultData);
        }
        if (resultStatus == "progress") {
            isFinished = false;
            callBackDict.progress(resultData);
        }

        if (isFinished) {
            window.KGCallBackList[identifier] = null;
            delete window.KGCallBackList[identifier];
        }
    }
}

function call(bridgeObjc) {
    var dataString = encodeURIComponent(JSON.stringify(bridgeObjc.data));
    var timestamp = Date.parse(new Date());
    var identifier = (bridgeObjc.target + bridgeObjc.action + dataString + timestamp).hashCode().toString();
    window.KGCallBackList[identifier] = bridgeObjc.callback;
    window.KGJsBridgeAndroid.call(bridgeObjc.action,JSON.stringify(bridgeObjc.data),identifier);
}

function util(method, parameter, success, fail) {
    var bridgeObjc = {
        target : "KGWebCommon",
        action : method,
        data : parameter,
        callback : {
            success : success,
            fail : fail,
        }
    };
    this.call(bridgeObjc);
}

var JSCallBackMethodManager = {
    removeAllCallBacks: function(data){
        window.KGCallBackList = {};
    }
};
